package com.jagrosh.jmusicbot.queue;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author John Grosh (jagrosh)
 * @author Jill "oatmealine" Monoids
 * @param <T>
 */
public abstract class Queue<T extends Queueable> {
  public abstract int add(T item);

  public abstract void addAt(int index, T item);

  public abstract int size();

  public abstract T pull();

  public abstract boolean isEmpty();

  public abstract List<T> getList();

  public abstract T get(int index);

  public abstract T remove(int index);

  public abstract int removeAll(long identifier);

  public abstract void clear();

  public abstract int shuffle(long identifier);

  public abstract int shuffle();

  public abstract void skip(int number);

  /**
   * Move an item to a different position in the list
   * @param from The position of the item
   * @param to The new position of the item
   * @return the moved item
   */
  public abstract T moveItem(int from, int to);
}
